/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package com.aliyun.batchcompute.job.logcount;


import com.aliyun.batchcompute.job.logcount.pojo.CountInfo;

import java.io.*;

/**
 * Created by guangchun.luo on 16/3/2.
 */
public class Count {

    static String instanceId = System.getenv("BATCH_COMPUTE_DAG_INSTANCE_ID");


    public static void main(String[] args) throws Exception {

        String INPUT= "/home/input";
        String OUTPUT = "/home/output";


        String inputPath = INPUT+"/split_results/"+instanceId+".txt";

        String outputPath = OUTPUT+"/count_results/"+instanceId+".json";

        new File(OUTPUT+"/count_results/").mkdir();

        InputStream is = new FileInputStream(inputPath);
        BufferedReader br = new BufferedReader(new InputStreamReader(is));

        CountInfo countInfo = new CountInfo();

        String line = null;
        while ((line = br.readLine()) != null) {
            if(line.indexOf("[INFO]")!=-1){
                countInfo.info++;
            }
             else if(line.indexOf("[ERROR]")!=-1){
                countInfo.error++;
            }
            else if(line.indexOf("[DEBUG]")!=-1){
                countInfo.debug++;
            }
            else {
                countInfo.warn++;
            }
        }

        br.close();

        System.out.println("count: "+countInfo.toString());

        FileWriter fw = new FileWriter(outputPath, false);
        fw.write(countInfo.toString());
        fw.close();


    }
}