/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package com.aliyun.batchcompute.job.logcount;

import com.aliyun.batchcompute.job.logcount.pojo.CountInfo;
import org.codehaus.jackson.map.ObjectMapper;

import java.io.*;

/**
 * Created by guangchun.luo on 16/3/2.
 */
public class Merge {

    public static void main(String[] args) throws Exception {

        String INPUT= "/home/input";
        String OUTPUT = "/home/output";

        String outputPath = OUTPUT+"/merge_result.json";

        BufferedReader totalBr = new BufferedReader(new InputStreamReader(new FileInputStream(INPUT+"/total.txt")));
        int total = Integer.parseInt(totalBr.readLine().trim());
        totalBr.close();


        CountInfo countInfo = new CountInfo();

        for(int i=0;i < total;i++){
            String inputPath = INPUT+"/count_results/"+i+".json";

            BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(inputPath)));

            StringBuilder sb = new StringBuilder();
            String line = null;
            while ((line = br.readLine()) != null) {
                sb.append(line).append("\n");
            }
            br.close();


            ObjectMapper mapper = new ObjectMapper();
            CountInfo countInfo2 = mapper.readValue(sb.toString(), CountInfo.class);

            countInfo = concatCountInfo(countInfo, countInfo2);
        }


        System.out.println("merge: "+countInfo.toString());

        FileWriter fw = new FileWriter(outputPath, false);
        fw.write(countInfo.toString());
        fw.close();

    }

    private static CountInfo concatCountInfo(CountInfo info, CountInfo info2){
        info.debug += info2.debug;
        info.info += info2.info;
        info.warn += info2.warn;
        info.error += info2.error;
        return info;
    }
}
